diff --git a/.gitignore b/.gitignore
index 45703399b0..2a3bc43ef2 100644
--- a/.gitignore
+++ b/.gitignore
@@ -171,6 +171,7 @@
 /git-tag
 /git-unpack-file
 /git-unpack-objects
+/git-update
 /git-update-index
 /git-update-ref
 /git-update-server-info
diff --git a/Documentation/config.txt b/Documentation/config.txt
index bf82766a6a..fc4b49c0d4 100644
--- a/Documentation/config.txt
+++ b/Documentation/config.txt
@@ -440,6 +440,8 @@ include::config/rerere.txt[]
 
 include::config/reset.txt[]
 
+include::config/update.txt[]
+
 include::config/sendemail.txt[]
 
 include::config/sequencer.txt[]
diff --git a/Documentation/git-update.txt b/Documentation/git-update.txt
new file mode 100644
index 0000000000..54c49c5d12
--- /dev/null
+++ b/Documentation/git-update.txt
@@ -0,0 +1,32 @@
+git-update(1)
+=============
+
+NAME
+----
+git-update - Update the current branch to the latest remote
+
+SYNOPSIS
+--------
+[verse]
+'git update'
+
+DESCRIPTION
+-----------
+
+Incorporates changes from a remote repository into the current branch.
+
+`git update` runs `git fetch` and then tries to advance the current branch to
+the remote branch with `git fast-forward`. If you don't have any extra changes
+the update operation is straight-forward, but if you do a further `git merge` or
+`git rebase` will be needed.
+
+THIS COMMAND IS EXPERIMENTAL. THE BEHAVIOUR MAY CHANGE.
+
+SEE ALSO
+--------
+linkgit:git-fetch[1], linkgit:git-fast-forward[1],
+linkgit:git-merge[1], linkgit:git-rebase[1]
+
+GIT
+---
+Part of the linkgit:git[1] suite
diff --git a/Makefile b/Makefile
index cf42162a07..6450574feb 100644
--- a/Makefile
+++ b/Makefile
@@ -1161,6 +1161,7 @@ BUILTIN_OBJS += builtin/symbolic-ref.o
 BUILTIN_OBJS += builtin/tag.o
 BUILTIN_OBJS += builtin/unpack-file.o
 BUILTIN_OBJS += builtin/unpack-objects.o
+BUILTIN_OBJS += builtin/update.o
 BUILTIN_OBJS += builtin/update-index.o
 BUILTIN_OBJS += builtin/update-ref.o
 BUILTIN_OBJS += builtin/update-server-info.o
diff --git a/builtin.h b/builtin.h
index 601e438c9b..7d18897682 100644
--- a/builtin.h
+++ b/builtin.h
@@ -229,6 +229,7 @@ int cmd_tag(int argc, const char **argv, const char *prefix);
 int cmd_tar_tree(int argc, const char **argv, const char *prefix);
 int cmd_unpack_file(int argc, const char **argv, const char *prefix);
 int cmd_unpack_objects(int argc, const char **argv, const char *prefix);
+int cmd_update(int argc, const char **argv, const char *prefix);
 int cmd_update_index(int argc, const char **argv, const char *prefix);
 int cmd_update_ref(int argc, const char **argv, const char *prefix);
 int cmd_update_server_info(int argc, const char **argv, const char *prefix);
diff --git a/builtin/update.c b/builtin/update.c
new file mode 100644
index 0000000000..51e45b453d
--- /dev/null
+++ b/builtin/update.c
@@ -0,0 +1,48 @@
+/*
+ * Copyright (C) 2021 Felipe Contreras
+ */
+
+#include "builtin.h"
+#include "run-command.h"
+#include "dir.h"
+
+static int run_fetch(void)
+{
+	struct strvec args = STRVEC_INIT;
+	int ret;
+
+	strvec_pushl(&args, "fetch", "--update-head-ok", NULL);
+
+	ret = run_command_v_opt(args.v, RUN_GIT_CMD);
+	strvec_clear(&args);
+	return ret;
+}
+
+static int run_fast_forward(void)
+{
+	struct strvec args = STRVEC_INIT;
+	int ret;
+
+	strvec_pushl(&args, "fast-forward", "FETCH_HEAD", NULL);
+
+	ret = run_command_v_opt(args.v, RUN_GIT_CMD);
+	strvec_clear(&args);
+	return ret;
+}
+
+int cmd_update(int argc, const char **argv, const char *prefix)
+{
+	if (!getenv("GIT_REFLOG_ACTION"))
+		setenv("GIT_REFLOG_ACTION", "update", 0);
+
+	if (repo_read_index_unmerged(the_repository))
+		die_resolve_conflict("update");
+
+	if (file_exists(git_path_merge_head(the_repository)))
+		die_conclude_merge();
+
+	if (run_fetch())
+		return 1;
+
+	return run_fast_forward();
+}
diff --git a/contrib/completion/git-completion.bash b/contrib/completion/git-completion.bash
index cfaee3aaeb..c5214d9856 100644
--- a/contrib/completion/git-completion.bash
+++ b/contrib/completion/git-completion.bash
@@ -3257,6 +3257,18 @@ _git_tag ()
 	esac
 }
 
+_git_update ()
+{
+	case "$cur" in
+	--*)
+		__gitcomp_builtin update
+
+		return
+		;;
+	esac
+	__git_complete_remote_or_refspec
+}
+
 _git_whatchanged ()
 {
 	_git_log
diff --git a/git.c b/git.c
index 6ab1fb9251..0156ea81a4 100644
--- a/git.c
+++ b/git.c
@@ -610,6 +610,7 @@ static struct cmd_struct commands[] = {
 	{ "tag", cmd_tag, RUN_SETUP | DELAY_PAGER_CONFIG },
 	{ "unpack-file", cmd_unpack_file, RUN_SETUP | NO_PARSEOPT },
 	{ "unpack-objects", cmd_unpack_objects, RUN_SETUP | NO_PARSEOPT },
+	{ "update", cmd_update, RUN_SETUP | NEED_WORK_TREE },
 	{ "update-index", cmd_update_index, RUN_SETUP },
 	{ "update-ref", cmd_update_ref, RUN_SETUP },
 	{ "update-server-info", cmd_update_server_info, RUN_SETUP },
diff --git a/t/t5563-update.sh b/t/t5563-update.sh
new file mode 100755
index 0000000000..951df41ac4
--- /dev/null
+++ b/t/t5563-update.sh
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+test_description='update'
+
+GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME=master
+export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
+
+. ./test-lib.sh
+
+test_expect_success 'setup' '
+	echo one > file &&
+	git add file &&
+	git commit -a -m one &&
+	echo two > file &&
+	git commit -a -m two
+'
+
+test_expect_success 'basic update' '
+	test_when_finished "rm -rf test" &&
+	(
+	git clone . test &&
+	cd test &&
+	git reset --hard @^ &&
+	git update &&
+	test_cmp_rev master origin/master
+	)
+'
+
+test_expect_success 'non-fast-forward update' '
+	test_when_finished "rm -rf test" &&
+	(
+	git clone . test &&
+	cd test &&
+	git checkout -b other master^ &&
+	>new &&
+	git add new &&
+	git commit -m new &&
+	git checkout -b test -t other &&
+	git reset --hard master &&
+	test_must_fail git update &&
+	test_cmp_rev @ master
+	)
+'
+
+test_done